package test;

import java.io.File;
import java.io.IOException;
import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;

import javax.sql.DataSource;

import com.poscoict.glueframework.biz.control.GlueBizControlConstants;
import com.poscoict.glueframework.biz.control.GlueBizController;
import com.poscoict.glueframework.biz.control.GlueBizProvider;
import com.poscoict.glueframework.context.GlueContext;
import com.poscoict.glueframework.context.GlueDefaultContext;
import com.poscoict.glueframework.context.GlueStaticContext;

public class Test_biz_m2_error3 {
    public static void main(String[] args) throws SQLException, IOException {
        File baseDir = new File("." + File.separator + "etc");
        System.setProperty("CONFIG_PATH", baseDir.getCanonicalPath());
        System.out.println("=================================== 시작 ");
        DataSource ds = GlueStaticContext.getBeanFactory().getBeanObject("biz-dataSource", DataSource.class);
        Connection con = ds.getConnection();
        Statement stmt = con.createStatement();
        stmt.execute("delete from emp where deptno=40 or empno in (1111,1112,1113,1114,1115)");
        con.commit();
        stmt.close();
        con.close();
        System.out.println("delete from emp where deptno=40");

        DataSource ds2 = GlueStaticContext.getBeanFactory().getBeanObject("biz2-dataSource", DataSource.class);
        Connection con2 = ds2.getConnection();
        Statement stmt2 = con2.createStatement();
        stmt2.execute("delete from emp where deptno=40 or empno in (1111,1112,1113,1114,1115)");
        stmt2.execute("insert into emp(empno, ename, deptno) values(1111, 'yujin', 40)");
        con2.commit();
        stmt2.close();
        con2.close();
        System.out.println("=================================== bean 생성완료");
        System.out.println("시나리오#2 - 에러유발 Start - 'CRUD#3' Activity");

        GlueContext ctx = new GlueDefaultContext();
        ctx.put(GlueBizControlConstants.SERVICE_NAME, "biz-m2-service");
        System.out.println("=================================== GlueContext 생성완료");
        GlueBizController controller = GlueBizProvider.getController();
        try {
            controller.doAction(ctx);
        } catch (Throwable t) {
            t.printStackTrace();
        }
        System.out.println("=================================== GlueService 실행완료");
        System.out.println("시나리오#2 - 에러유발 End - 'CRUD#3' Activity");
        System.out.println("=================================== 종료 ");

        con = ds.getConnection();
        stmt = con.createStatement();
        ResultSet rs = stmt.executeQuery("select * from emp where deptno=40 or empno in (1111,1112,1113,1114,1115)");
        while (rs.next()) {
            System.out.println(rs.getInt("EMPNO") + "|" + rs.getString("ENAME") + "|" + rs.getInt("DEPTNO"));
        }
        rs.close();
        stmt.close();
        con.close();

        con2 = ds2.getConnection();
        stmt2 = con2.createStatement();
        ResultSet rs2 = stmt2.executeQuery("select * from emp where deptno=40 or empno in (1111,1112,1113,1114,1115)");
        while (rs2.next()) {
            System.out.println(rs2.getInt("EMPNO") + "|" + rs2.getString("ENAME") + "|" + rs2.getInt("DEPTNO"));
        }
        rs2.close();
        stmt2.close();
        con2.close();
    }
}